> For the complete documentation index, see [llms.txt](https://docs.mezzanine.xyz/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.mezzanine.xyz/smart-contracts/source-code/core/base/mezzuupsupgradeable.md).

# MezzUUPSUpgradeable

[Git Source](https://github.com/EntreDevelopers-Lab-Inc/Mezz-Companies/blob/f7a3e84e3dd5bb33c4bd7f77283983f9e8ba20b2/src/core/base/MezzUUPSUpgradeable.sol)

**Inherits:** Credentialed, UUPSUpgradeable, IMezzUUPSUpgradeable

**Author:** Daniel Yamagata & Naveen Ailawadi

A base contract inherited by user-facing, upgradeable core contract

*All calls to 'upgradeToAndCall()' must be made by the Mezz Migrator*

## State Variables

### MEZZ\_MIGRATOR

```solidity
IMezzMigrator public immutable MEZZ_MIGRATOR;
```

## Functions

### constructor

```solidity
constructor(address _mezzMigrator);
```

### supportsInterface

*ERC165 support*

```solidity
function supportsInterface(bytes4 interfaceId) public view virtual override(Credentialed, IERC165) returns (bool);
```

### \_authorizeUpgrade

*Called in UUPSUpgradeable's upgradeToAndCall(...). Overridden such that the caller must be MEZZ\_MIGRATOR.*

```solidity
function _authorizeUpgrade(address) internal virtual override;
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.mezzanine.xyz/smart-contracts/source-code/core/base/mezzuupsupgradeable.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
